<script lang="ts">
import Vue from 'vue';
import { StsMarketoForm } from '../components/dedicated/index.vue';
import { QuotesCarousel } from '../components/home/index.vue';
import { getPageMetadata } from '~/common/meta';
import { NextStep, ReportCta } from '~/components/common/index.vue';
import { CONTENT_TYPES } from '~/common/content-types';
import { getClient } from '~/plugins/contentful.js';
import {
  ValueStreamsData,
  valueStreamsHelper,
} from '~/services/value-streams/value-streams.service';

export default Vue.extend({
  components: {
    NextStep,
    StsMarketoForm,
    QuotesCarousel,
    ReportCta,
  },
  nuxtI18n: false,
  async asyncData() {
    const content: ValueStreamsData = await getClient()
      .getEntries({
        content_type: CONTENT_TYPES.PAGE,
        include: 10,
        'fields.slug': 'value-stream-workshop',
      })
      .then((query: any) => {
        const entryFields: ValueStreamsData = query.items[0]?.fields;
        return valueStreamsHelper(entryFields);
      })
      .catch((e) => {
        throw new Error(e);
      });
    return { content };
  },
  head() {
    return getPageMetadata((this as any).content, this.$route.path);
  },
});
</script>

<template>
  <div class="dedicated-wrapper">
    <component
      :is="component.name"
      v-for="component in content.components"
      :key="component.name"
      :data="component.data"
    />
    <NextStep :variant="content.nextSteps" />
  </div>
</template>
<style scoped lang="scss">
.dedicated-wrapper {
  overflow: hidden;

  :deep {
    .security-resources-feature .slp-row.slp-align-items-center {
      align-items: flex-end;
    }
  }
}
</style>
